BuildSettings (Grails 2.3.8)
Date: 2014-04-24

Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | PROPERTY | CONSTR | METHOD | DETAIL: FIELD | PROPERTY | CONSTR | METHOD

## grails.util
[Groovy] Class BuildSettings

    java.lang.Object
      grails.util.AbstractBuildSettings
          grails.util.BuildSettings

    class BuildSettings
    extends AbstractBuildSettings

Represents the project paths and other build settings that the user can change when running the Grails commands. Defaults are provided for all settings, but the user can override those by setting the appropriate system property or specifying a value for it in the BuildConfig.groovy file.

Warning The behaviour is poorly defined if you explicitly set some of the project paths (such as BuildSettings.projectWorkDir), but not others. If you set one of them explicitly, set all of them to ensure consistent behaviour.

Field Summary
`static java.lang.String` | `APP_BASE_DIR` The base directory of the application
`static java.lang.String` | `BUILD_LISTENERS` The name of the system property for multiple buildListeners.
`static java.lang.String` | `COMPILER_SOURCE_LEVEL` The compiler source level to use
`static java.lang.String` | `COMPILER_TARGET_LEVEL` The compiler source level to use
`static java.lang.String` | `CONVERT_CLOSURES_KEY` A property name to enable/disable AST conversion of closures actions&tags to methods
`static java.lang.String` | `CORE_WORKING_DIR_NAME` The name of the working directory for commands that don't belong to a project (like create-app)
`static java.lang.String` | `DEPENDENCY_RESOLVER` The dependency resolver to use
`static java.lang.String` | `FUNCTIONAL_BASE_URL_PROPERTY` A system property with this name is populated in the preparation phase of functional testing with the base URL that tests should be run against.
`static java.lang.String` | `GLOBAL_PLUGINS_DIR` The name of the system property for globalPluginsDir.
`static java.lang.String` | `LOG_SCRIPT_TIMING_KEY` Property name to enable/disable script event time logging.
`static java.lang.String` | `OFFLINE_MODE`
`static java.lang.String` | `PLUGINS_DIR` The name of the system property for projectPluginsDir.
`static java.lang.String` | `PLUGIN_INCLUDE_SOURCE` The name of the system property for pluginIncludeSource.
`static java.lang.String` | `PLUGIN_STAGING_DIR` The name of the system property for pluginStagingDir.
`static java.lang.String` | `PROJECT_AUTODEPLOY_DIR` The name of the WAR file of the project
`static java.lang.String` | `PROJECT_CLASSES_DIR` The name of the system property for classesDir.
`static java.lang.String` | `PROJECT_DOCS_OUTPUT_DIR` The name of the system property for docsOutputDir.
`static java.lang.String` | `PROJECT_PLUGIN_BUILD_CLASSES_DIR` The name of the system property for pluginBuildClassesDir.
`static java.lang.String` | `PROJECT_PLUGIN_CLASSES_DIR` The name of the system property for pluginClassesDir.
`static java.lang.String` | `PROJECT_PLUGIN_PROVIDED_CLASSES_DIR` The name of the system property for pluginProvidedClassesDir.
`static java.lang.String` | `PROJECT_RESOURCES_DIR` The name of the system property for .
`static java.lang.String` | `PROJECT_SOURCE_DIR` The name of the system property for sourceDir.
`static java.lang.String` | `PROJECT_TARGET_DIR` The name of the system property for projectTargetDir.
`static java.lang.String` | `PROJECT_TEST_CLASSES_DIR` The name of the system property for testClassesDir.
`static java.lang.String` | `PROJECT_TEST_REPORTS_DIR` The name of the system property for testReportsDir.
`static java.lang.String` | `PROJECT_TEST_SOURCE_DIR` The name of the system property for testSourceDir.
`static java.lang.String` | `PROJECT_WAR_EXPLODED_DIR` The name of the system property for projectWarExplodedDir.
`static java.lang.String` | `PROJECT_WAR_FILE` The name of the WAR file of the project
`static java.lang.String` | `PROJECT_WAR_OSGI_HEADERS` The name of the system property for enabling osgi headers in the WAR Manifest
`static java.lang.String` | `PROJECT_WEB_XML_FILE` The name of the system property for BuildSettings.webXmlLocation.
`static java.lang.String` | `PROJECT_WORK_DIR` The name of the system property for projectWorkDir.
`static java.lang.String` | `SERVLET_VERSION` The version of the servlet API
`static java.lang.String` | `VERBOSE_COMPILE` The name of the system property for enabling verbose compilation verboseCompile.
`static java.lang.String` | `WORK_DIR` The name of the system property for grailsWorkDir.
`protected boolean` | `settingsFileLoaded`

Fields inherited from class AbstractBuildSettings
cache, config, flatConfig, globalPluginsDir, globalPluginsDirSet, projectPluginsDir, projectPluginsDirSet

Property Summary
`static java.lang.String` | `BUILD_SCOPE`
`static java.lang.String` | `BUILD_SCOPE_DESC`
`static java.lang.String` | `COMPILE_SCOPE`
`static java.lang.String` | `COMPILE_SCOPE_DESC`
`static java.util.regex.Pattern` | `JAR_PATTERN`
`static java.lang.String` | `PROVIDED_SCOPE`
`static java.lang.String` | `PROVIDED_SCOPE_DESC`
`static java.lang.String` | `RUNTIME_SCOPE`
`static java.lang.String` | `RUNTIME_SCOPE_DESC`
`static java.util.Map` | `SCOPE_TO_DESC`
`static java.lang.String` | `TEST_SCOPE`
`static java.lang.String` | `TEST_SCOPE_DESC`
`java.util.List` | `applicationJars` List of jars provided in the applications 'lib' directory
`java.io.File` | `autodeployDir` Directory where additional war files to be autodeployed are located
`java.io.File` | `baseDir` The base directory for the build, which is normally the root directory of the current project.
`java.util.List` | `buildListeners`
`DependencyReport` | `buildResolveReport`
`java.io.File` | `classesDir` The location to which Grails compiles a project's classes.
`DependencyReport` | `compileResolveReport`
`java.lang.String` | `compilerSourceLevel` The compiler source level to use
`java.lang.String` | `compilerTargetLevel` The compiler target level to use
`boolean` | `convertClosuresArtefacts`
`GrailsCoreDependencies` | `coreDependencies`
`java.util.List` | `defaultBuildDependencies`
`java.util.List` | `defaultCompileDependencies`
`boolean` | `defaultEnv` `true` if the default environment for a script should be used.
`java.util.Map` | `defaultPluginMap` A Set of plugin names and versions that represent the default set of plugins installed when creating Grails applications
`java.util.Set` | `defaultPluginSet` A Set of plugin names that represent the default set of plugins installed when creating Grails applications
`java.util.List` | `defaultProvidedDependencies`
`java.util.List` | `defaultRuntimeDependencies`
`java.util.List` | `defaultTestDependencies`
`boolean` | `dependenciesExternallyConfigured` Whether the project required build dependencies are externally configured (by Maven for example) or not
`DependencyManager` | `dependencyManager` Manages dependencies and dependency resolution in a Grails application
`java.lang.String` | `dependencyResolver` The dependency resolution engine to use (aether or ivy)
`java.io.File` | `docsOutputDir` The location of the documentation output.
`boolean` | `enableResolve` Whether to enable resolving dependencies
`java.util.Map` | `forkSettings` Fork Settings.
`java.lang.String` | `grailsEnv` The environment for the current script.
`java.io.File` | `grailsHome` Location of the Grails distribution as usually identified by the GRAILS_HOME environment variable.
`java.lang.String` | `grailsVersion` The version of Grails being used for the current script.
`java.io.File` | `grailsWorkDir` The location of the Grails working directory where non-project-specific temporary files are stored.
`boolean` | `includeJavadoc` whether to include javadoc attachments in a resolve
`boolean` | `includeSource` whether to include source attachments in a resolve
`boolean` | `logScriptTiming`
`boolean` | `modified` Return whether the BuildConfig has been modified
`boolean` | `offline` Whether the build is allowed to connect to remote servers to resolve dependencies
`java.io.File` | `pluginBuildClassesDir` The location to which Grails compiles build scoped plugins classes.
`java.io.File` | `pluginClassesDir` The location to which Grails compiles a project's plugin classes.
`java.util.List` | `pluginDependencies`
`java.lang.Boolean` | `pluginIncludeSource` Whether to include the source in binary plugin JAR files.
`java.io.File` | `pluginProvidedClassesDir` The location to which Grails compiles provided scoped plugins classes.
`java.io.File` | `pluginStagingDir` The location of the temporary directory where plugins are staged before being bundled into a ZIP or JAR file.
`java.io.File` | `projectTargetDir` The location of the project target directory where reports, artifacts and so on are output.
`java.io.File` | `projectWarExplodedDir` The location of the Grails WAR directory where exploded WAR is built.
`java.io.File` | `projectWarFile` The WAR file of the project
`boolean` | `projectWarOsgiHeaders` Setting for whether or not to enable OSGI headers in the WAR Manifest, can be overridden via -verboseCompile(=[true|false])?
`java.io.File` | `projectWorkDir` The location of the project working directory for project-specific temporary files.
`DependencyReport` | `providedResolveReport`
`groovy.util.ConfigObject` | `proxySettings` The settings used to establish the HTTP proxy to use for dependency resolution etc.
`java.io.File` | `proxySettingsFile` The file containing the proxy settings
`java.io.File` | `resourcesDir` The location where Grails keeps temporary copies of a project's resources.
`java.net.URLClassLoader` | `rootLoader` The root loader for the build.
`DependencyReport` | `runtimeResolveReport`
`java.lang.String` | `servletVersion` The version of the servlet API used
`java.io.File` | `sourceDir` The location of the plain source.
`java.io.File` | `testClassesDir` The location to which Grails compiles a project's test classes and any test scoped plugin classes.
`java.io.File` | `testReportsDir` The location of the test reports.
`DependencyReport` | `testResolveReport`
`java.io.File` | `testSourceDir` The location of the test source.
`java.io.File` | `userHome` Location of the current user's home directory - equivalent to "user.home" system property.
`boolean` | `verboseCompile` Setting for whether or not to enable verbose compilation, can be overridden via -verboseCompile(=[true|false])?
`java.io.File` | `webXmlLocation` Location of the generated web.xml file

Constructor Summary
`BuildSettings()`
`BuildSettings(java.io.File grailsHome)`
`BuildSettings(java.io.File grailsHome, java.io.File baseDir)`

Method Summary
`DependencyManager` | `configureDependencyManager()`
`protected void` | `copyDirectoryContentsToTarget(java.io.File dir, java.lang.String targetPath)`
`groovy.util.ConfigSlurper` | `createConfigSlurper()`
`DependencyManager` | `createNewDependencyManager()`
`java.util.List` | `doResolve(java.lang.String scope, java.util.List pluginZips, boolean includeAppJars = true)`
`java.io.File` | `getBasePluginDescriptor()`
`java.util.List` | `getBuildDependencies()` List containing the runtime dependencies of the app as File instances.
`java.lang.Object[]` | `getBuildListeners()`
`java.util.List` | `getCompileDependencies()` List containing the compile-time dependencies of the app as File instances.
`java.io.File` | `getConfigFile()`
`java.lang.String` | `getConfigFilePath()` @return The path to the Config.groovy file (not to be confused with BuildConfig.groovy)
`java.lang.String` | `getFunctionalTestBaseUrl()`
`groovy.lang.Closure` | `getGrailsScriptClosure()`
`protected java.lang.Object` | `getInlinePluginDependencyConfig(groovy.util.ConfigObject pluginConfig)`
`java.util.List` | `getPluginBuildDependencies()` Obtains a list of source plugins that are build time dependencies
`java.util.List` | `getPluginCompileDependencies()` Obtains a list of source plugins that are provided time dependencies
`java.util.List` | `getPluginProvidedDependencies()` Obtains a list of source plugins that are provided time dependencies
`java.util.List` | `getPluginRuntimeDependencies()` Obtains a list of source plugins that are runtime time dependencies
`java.util.List` | `getPluginTestDependencies()` Obtains a list of source plugins that are test time dependencies
`java.util.List` | `getProvidedDependencies()` List containing the runtime dependencies of the app as File instances.
`java.util.List` | `getRuntimeDependencies()` List containing the runtime dependencies of the app as File instances.
`java.util.List` | `getTestDependencies()` List containing the test-time dependencies of the app as File instances.
`java.io.File` | `getWebXmlLocation()`
`void` | `handleInlinePlugin(java.lang.String pluginName, java.io.File dir, DependencyManager dependencyManager)`
`static void` | `initialiseDefaultLog4j(java.lang.ClassLoader classLoader)`
`void` | `initializeResourcesDir()`
`boolean` | `isDependenciesExternallyConfigured()`
`boolean` | `isGrailsProject()`
`boolean` | `isPluginProject()`
`boolean` | `isRegisteredInMetadata(java.lang.String pluginName)`
`protected void` | `loadBuildPropertiesFromClasspath(java.util.Properties buildProps)`
`groovy.util.ConfigObject` | `loadConfig(java.lang.String environment = null)` Loads the application's BuildSettings.groovy file if it exists and returns the corresponding config object.
`groovy.util.ConfigObject` | `loadConfig(java.io.File configFile, java.lang.String environment = null)` Loads the given configuration file if it exists and returns the corresponding config object.
`groovy.util.ConfigObject` | `loadConfig(groovy.lang.Script script, java.lang.String environment = null)` Loads the given script and returns corresponding config object.
`groovy.util.ConfigObject` | `loadConfig(groovy.util.ConfigObject config)`
`protected groovy.util.ConfigObject` | `loadSettingsFile()`
`protected java.io.File` | `makeAbsolute(java.io.File dir)`
`boolean` | `notDefinedInBuildConfig(java.lang.String pluginName)`
`groovy.lang.GroovyClassLoader` | `obtainGroovyClassLoader()`
`protected void` | `parseGrailsBuildListeners()`
`protected void` | `postLoadConfig()`
`void` | `setBaseDir(java.io.File newBaseDir)`
`void` | `setBuildDependencies(java.util.List deps)` Sets the runtime dependencies for the project
`void` | `setBuildListeners(java.lang.Object buildListeners)`
`void` | `setClassesDir(java.io.File dir)`
`void` | `setCompileDependencies(java.util.List deps)` Sets the compile time dependencies for the project
`void` | `setConvertClosuresArtefacts(boolean convert)`
`void` | `setDependenciesExternallyConfigured(boolean dependenciesExternallyConfigured)`
`void` | `setGrailsWorkDir(java.io.File dir)`
`void` | `setLogScriptTiming(boolean b)`
`void` | `setPluginBuildClassesDir(java.io.File dir)`
`void` | `setPluginClassesDir(java.io.File dir)`
`void` | `setPluginIncludeSource(boolean include)`
`void` | `setPluginProvidedClassesDir(java.io.File dir)`
`void` | `setPluginStagingDir(java.io.File dir)`
`void` | `setProjectTargetDir(java.io.File dir)`
`void` | `setProjectWarExplodedDir(java.io.File dir)`
`void` | `setProjectWarFile(java.io.File file)`
`void` | `setProjectWarOsgiHeaders(boolean flag)`
`void` | `setProjectWorkDir(java.io.File dir)`
`void` | `setProvidedDependencies(java.util.List deps)` Sets the runtime dependencies for the project
`void` | `setResourcesDir(java.io.File dir)`
`void` | `setRuntimeDependencies(java.util.List deps)` Sets the runtime dependencies for the project
`void` | `setSourceDir(java.io.File dir)`
`void` | `setTestClassesDir(java.io.File dir)`
`void` | `setTestDependencies(java.util.List deps)` Sets the test time dependencies for the project
`void` | `setTestReportsDir(java.io.File dir)`
`void` | `setTestSourceDir(java.io.File dir)`
`void` | `setVerboseCompile(boolean flag)`
`void` | `setWebXmlLocation(java.io.File location)`
`protected boolean` | `shouldResolve()`
`void` | `storeDependencyCache()`

Methods inherited from class AbstractBuildSettings
addPluginDirectory, getConfig, getGlobalPluginsDir, getImplicitPluginDirectories, getInlinePluginDirectories, getInlinePluginsFromConfiguration, getInlinePluginsFromConfiguration, getPluginBaseDirectories, getPluginDirectories, getProjectPluginsDir, isInlinePluginLocation, setConfig, setGlobalPluginsDir, setProjectPluginsDir

Methods inherited from class java.lang.Object
java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()

Field Detail

### APP_BASE_DIR

    public static final java.lang.String APP_BASE_DIR

  The base directory of the application

### BUILD_LISTENERS

    public static final java.lang.String BUILD_LISTENERS

  The name of the system property for multiple buildListeners.

### COMPILER_SOURCE_LEVEL

    public static final java.lang.String COMPILER_SOURCE_LEVEL

  The compiler source level to use

### COMPILER_TARGET_LEVEL

    public static final java.lang.String COMPILER_TARGET_LEVEL

  The compiler source level to use

### CONVERT_CLOSURES_KEY

    public static final java.lang.String CONVERT_CLOSURES_KEY

  A property name to enable/disable AST conversion of closures actions&tags to methods

### CORE_WORKING_DIR_NAME

    public static final java.lang.String CORE_WORKING_DIR_NAME

  The name of the working directory for commands that don't belong to a project (like create-app)

### DEPENDENCY_RESOLVER

    public static final java.lang.String DEPENDENCY_RESOLVER

  The dependency resolver to use

### FUNCTIONAL_BASE_URL_PROPERTY

    public static final java.lang.String FUNCTIONAL_BASE_URL_PROPERTY

  A system property with this name is populated in the preparation phase of functional testing with the base URL that tests should be run against.

### GLOBAL_PLUGINS_DIR

    public static final java.lang.String GLOBAL_PLUGINS_DIR

  The name of the system property for globalPluginsDir.

### LOG_SCRIPT_TIMING_KEY

    public static final java.lang.String LOG_SCRIPT_TIMING_KEY

  Property name to enable/disable script event time logging.

### OFFLINE_MODE

    public static final java.lang.String OFFLINE_MODE

### PLUGINS_DIR

    public static final java.lang.String PLUGINS_DIR

  The name of the system property for projectPluginsDir.

### PLUGIN_INCLUDE_SOURCE

    public static final java.lang.String PLUGIN_INCLUDE_SOURCE

  The name of the system property for pluginIncludeSource.

### PLUGIN_STAGING_DIR

    public static final java.lang.String PLUGIN_STAGING_DIR

  The name of the system property for pluginStagingDir.

### PROJECT_AUTODEPLOY_DIR

    public static final java.lang.String PROJECT_AUTODEPLOY_DIR

  The name of the WAR file of the project

### PROJECT_CLASSES_DIR

    public static final java.lang.String PROJECT_CLASSES_DIR

  The name of the system property for classesDir.

### PROJECT_DOCS_OUTPUT_DIR

    public static final java.lang.String PROJECT_DOCS_OUTPUT_DIR

  The name of the system property for docsOutputDir.

### PROJECT_PLUGIN_BUILD_CLASSES_DIR

    public static final java.lang.String PROJECT_PLUGIN_BUILD_CLASSES_DIR

  The name of the system property for pluginBuildClassesDir.

### PROJECT_PLUGIN_CLASSES_DIR

    public static final java.lang.String PROJECT_PLUGIN_CLASSES_DIR

  The name of the system property for pluginClassesDir.

### PROJECT_PLUGIN_PROVIDED_CLASSES_DIR

    public static final java.lang.String PROJECT_PLUGIN_PROVIDED_CLASSES_DIR

  The name of the system property for pluginProvidedClassesDir.

### PROJECT_RESOURCES_DIR

    public static final java.lang.String PROJECT_RESOURCES_DIR

  The name of the system property for .

### PROJECT_SOURCE_DIR

    public static final java.lang.String PROJECT_SOURCE_DIR

  The name of the system property for sourceDir.

### PROJECT_TARGET_DIR

    public static final java.lang.String PROJECT_TARGET_DIR

  The name of the system property for projectTargetDir.

### PROJECT_TEST_CLASSES_DIR

    public static final java.lang.String PROJECT_TEST_CLASSES_DIR

  The name of the system property for testClassesDir.

### PROJECT_TEST_REPORTS_DIR

    public static final java.lang.String PROJECT_TEST_REPORTS_DIR

  The name of the system property for testReportsDir.

### PROJECT_TEST_SOURCE_DIR

    public static final java.lang.String PROJECT_TEST_SOURCE_DIR

  The name of the system property for testSourceDir.

### PROJECT_WAR_EXPLODED_DIR

    public static final java.lang.String PROJECT_WAR_EXPLODED_DIR

  The name of the system property for projectWarExplodedDir.

### PROJECT_WAR_FILE

    public static final java.lang.String PROJECT_WAR_FILE

  The name of the WAR file of the project

### PROJECT_WAR_OSGI_HEADERS

    public static final java.lang.String PROJECT_WAR_OSGI_HEADERS

  The name of the system property for enabling osgi headers in the WAR Manifest

### PROJECT_WEB_XML_FILE

    public static final java.lang.String PROJECT_WEB_XML_FILE

  The name of the system property for BuildSettings.webXmlLocation.

### PROJECT_WORK_DIR

    public static final java.lang.String PROJECT_WORK_DIR

  The name of the system property for projectWorkDir.

### SERVLET_VERSION

    public static final java.lang.String SERVLET_VERSION

  The version of the servlet API

### VERBOSE_COMPILE

    public static final java.lang.String VERBOSE_COMPILE

  The name of the system property for enabling verbose compilation verboseCompile.

### WORK_DIR

    public static final java.lang.String WORK_DIR

  The name of the system property for grailsWorkDir.

### settingsFileLoaded

    protected boolean settingsFileLoaded

Property Detail

### BUILD_SCOPE

    static final java.lang.String BUILD_SCOPE

### BUILD_SCOPE_DESC

    static final java.lang.String BUILD_SCOPE_DESC

### COMPILE_SCOPE

    static final java.lang.String COMPILE_SCOPE

### COMPILE_SCOPE_DESC

    static final java.lang.String COMPILE_SCOPE_DESC

### JAR_PATTERN

    static final java.util.regex.Pattern JAR_PATTERN

### PROVIDED_SCOPE

    static final java.lang.String PROVIDED_SCOPE

### PROVIDED_SCOPE_DESC

    static final java.lang.String PROVIDED_SCOPE_DESC

### RUNTIME_SCOPE

    static final java.lang.String RUNTIME_SCOPE

### RUNTIME_SCOPE_DESC

    static final java.lang.String RUNTIME_SCOPE_DESC

### SCOPE_TO_DESC

    static final java.util.Map SCOPE_TO_DESC

### TEST_SCOPE

    static final java.lang.String TEST_SCOPE

### TEST_SCOPE_DESC

    static final java.lang.String TEST_SCOPE_DESC

### applicationJars

    java.util.List applicationJars

  List of jars provided in the applications 'lib' directory

### autodeployDir

    java.io.File autodeployDir

  Directory where additional war files to be autodeployed are located

### baseDir

    java.io.File baseDir

  The base directory for the build, which is normally the root directory of the current project. If a command is run outside of a project, then this will be the current working directory that the command was launched from.

### buildListeners

    java.util.List buildListeners

### buildResolveReport

    DependencyReport buildResolveReport

### classesDir

    java.io.File classesDir

  The location to which Grails compiles a project's classes.

### compileResolveReport

    DependencyReport compileResolveReport

### compilerSourceLevel

    java.lang.String compilerSourceLevel

  The compiler source level to use

### compilerTargetLevel

    java.lang.String compilerTargetLevel

  The compiler target level to use

### convertClosuresArtefacts

    boolean convertClosuresArtefacts

### coreDependencies

    GrailsCoreDependencies coreDependencies

### defaultBuildDependencies

    @groovy.lang.Lazy
    java.util.List defaultBuildDependencies

### defaultCompileDependencies

    @groovy.lang.Lazy
    java.util.List defaultCompileDependencies

### defaultEnv

    boolean defaultEnv

  `true` if the default environment for a script should be used.

### defaultPluginMap

    java.util.Map defaultPluginMap

  A Set of plugin names and versions that represent the default set of plugins installed when creating Grails applications

### defaultPluginSet

    java.util.Set defaultPluginSet

  A Set of plugin names that represent the default set of plugins installed when creating Grails applications

### defaultProvidedDependencies

    @groovy.lang.Lazy
    java.util.List defaultProvidedDependencies

### defaultRuntimeDependencies

    @groovy.lang.Lazy
    java.util.List defaultRuntimeDependencies

### defaultTestDependencies

    @groovy.lang.Lazy
    java.util.List defaultTestDependencies

### dependenciesExternallyConfigured

    boolean dependenciesExternallyConfigured

  Whether the project required build dependencies are externally configured (by Maven for example) or not

### dependencyManager

    DependencyManager dependencyManager

  Manages dependencies and dependency resolution in a Grails application

### dependencyResolver

    java.lang.String dependencyResolver

  The dependency resolution engine to use (aether or ivy)

### docsOutputDir

    java.io.File docsOutputDir

  The location of the documentation output.

### enableResolve

    boolean enableResolve

  Whether to enable resolving dependencies

### forkSettings

    java.util.Map forkSettings

  Fork Settings. These are the default settings used to control forked mode, and what

### grailsEnv

    java.lang.String grailsEnv

  The environment for the current script.

### grailsHome

    java.io.File grailsHome

  Location of the Grails distribution as usually identified by the GRAILS_HOME environment variable. This value may be `null` if GRAILS_HOME is not set, for example if a project uses the Grails JAR files directly.

### grailsVersion

    java.lang.String grailsVersion

  The version of Grails being used for the current script.

### grailsWorkDir

    java.io.File grailsWorkDir

  The location of the Grails working directory where non-project-specific temporary files are stored.

### includeJavadoc

    boolean includeJavadoc

  whether to include javadoc attachments in a resolve

### includeSource

    boolean includeSource

  whether to include source attachments in a resolve

### logScriptTiming

    boolean logScriptTiming

### modified

    boolean modified

  Return whether the BuildConfig has been modified

### offline

    boolean offline

  Whether the build is allowed to connect to remote servers to resolve dependencies

### pluginBuildClassesDir

    java.io.File pluginBuildClassesDir

  The location to which Grails compiles build scoped plugins classes.

### pluginClassesDir

    java.io.File pluginClassesDir

  The location to which Grails compiles a project's plugin classes. Plugin classes that are compile or runtime scoped will be compiled to this directory

### pluginDependencies

    java.util.List pluginDependencies

### pluginIncludeSource

    java.lang.Boolean pluginIncludeSource

  Whether to include the source in binary plugin JAR files.

### pluginProvidedClassesDir

    java.io.File pluginProvidedClassesDir

  The location to which Grails compiles provided scoped plugins classes.

### pluginStagingDir

    java.io.File pluginStagingDir

  The location of the temporary directory where plugins are staged before being bundled into a ZIP or JAR file.

### projectTargetDir

    java.io.File projectTargetDir

  The location of the project target directory where reports, artifacts and so on are output.

### projectWarExplodedDir

    java.io.File projectWarExplodedDir

  The location of the Grails WAR directory where exploded WAR is built.

### projectWarFile

    java.io.File projectWarFile

  The WAR file of the project

### projectWarOsgiHeaders

    boolean projectWarOsgiHeaders

  Setting for whether or not to enable OSGI headers in the WAR Manifest, can be overridden via -verboseCompile(=[true|false])?

### projectWorkDir

    java.io.File projectWorkDir

  The location of the project working directory for project-specific temporary files.

### providedResolveReport

    DependencyReport providedResolveReport

### proxySettings

    groovy.util.ConfigObject proxySettings

  The settings used to establish the HTTP proxy to use for dependency resolution etc.

### proxySettingsFile

    java.io.File proxySettingsFile

  The file containing the proxy settings

### resourcesDir

    java.io.File resourcesDir

  The location where Grails keeps temporary copies of a project's resources.

### rootLoader

    java.net.URLClassLoader rootLoader

  The root loader for the build. This has the required libraries on the classpath.

### runtimeResolveReport

    DependencyReport runtimeResolveReport

### servletVersion

    java.lang.String servletVersion

  The version of the servlet API used

### sourceDir

    java.io.File sourceDir

  The location of the plain source.

### testClassesDir

    java.io.File testClassesDir

  The location to which Grails compiles a project's test classes and any test scoped plugin classes.

### testReportsDir

    java.io.File testReportsDir

  The location of the test reports.

### testResolveReport

    DependencyReport testResolveReport

### testSourceDir

    java.io.File testSourceDir

  The location of the test source.

### userHome

    java.io.File userHome

  Location of the current user's home directory - equivalent to "user.home" system property.

### verboseCompile

    boolean verboseCompile

  Setting for whether or not to enable verbose compilation, can be overridden via -verboseCompile(=[true|false])?

### webXmlLocation

    java.io.File webXmlLocation

  Location of the generated web.xml file

Constructor Detail

### BuildSettings

    BuildSettings()

### BuildSettings

    BuildSettings(java.io.File grailsHome)

### BuildSettings

    BuildSettings(java.io.File grailsHome, java.io.File baseDir)

Method Detail

### configureDependencyManager

    @groovy.transform.CompileStatic
    DependencyManager configureDependencyManager()

### copyDirectoryContentsToTarget

    @groovy.transform.CompileStatic
    protected void copyDirectoryContentsToTarget(java.io.File dir, java.lang.String targetPath)

### createConfigSlurper

    @groovy.transform.CompileStatic
    groovy.util.ConfigSlurper createConfigSlurper()

### createNewDependencyManager

    @groovy.transform.CompileStatic
    DependencyManager createNewDependencyManager()

### doResolve

    @groovy.transform.CompileStatic
    java.util.List doResolve(java.lang.String scope, java.util.List pluginZips, boolean includeAppJars = true)

### getBasePluginDescriptor

    java.io.File getBasePluginDescriptor()

### getBuildDependencies

    @groovy.transform.CompileStatic
    java.util.List getBuildDependencies()

  List containing the runtime dependencies of the app as File instances.

### getBuildListeners

    java.lang.Object[] getBuildListeners()

### getCompileDependencies

    @groovy.transform.CompileStatic
    java.util.List getCompileDependencies()

  List containing the compile-time dependencies of the app as File instances.

### getConfigFile

    @groovy.transform.CompileStatic
    java.io.File getConfigFile()

### getConfigFilePath

    @groovy.transform.CompileStatic
    java.lang.String getConfigFilePath()

  Returns:
    The path to the Config.groovy file (not to be confused with BuildConfig.groovy)

### getFunctionalTestBaseUrl

    java.lang.String getFunctionalTestBaseUrl()

### getGrailsScriptClosure

    groovy.lang.Closure getGrailsScriptClosure()

### getInlinePluginDependencyConfig

    protected java.lang.Object getInlinePluginDependencyConfig(groovy.util.ConfigObject pluginConfig)

### getPluginBuildDependencies

    @groovy.transform.CompileStatic
    java.util.List getPluginBuildDependencies()

  Obtains a list of source plugins that are build time dependencies
  Returns:
    A list of the source zips

### getPluginCompileDependencies

    @groovy.transform.CompileStatic
    java.util.List getPluginCompileDependencies()

  Obtains a list of source plugins that are provided time dependencies
  Returns:
    A list of the source zips

### getPluginProvidedDependencies

    @groovy.transform.CompileStatic
    java.util.List getPluginProvidedDependencies()

  Obtains a list of source plugins that are provided time dependencies
  Returns:
    A list of the source zips

### getPluginRuntimeDependencies

    @groovy.transform.CompileStatic
    java.util.List getPluginRuntimeDependencies()

  Obtains a list of source plugins that are runtime time dependencies
  Returns:
    A list of the source zips

### getPluginTestDependencies

    @groovy.transform.CompileStatic
    java.util.List getPluginTestDependencies()

  Obtains a list of source plugins that are test time dependencies
  Returns:
    A list of the source zips

### getProvidedDependencies

    @groovy.transform.CompileStatic
    java.util.List getProvidedDependencies()

  List containing the runtime dependencies of the app as File instances.

### getRuntimeDependencies

    @groovy.transform.CompileStatic
    java.util.List getRuntimeDependencies()

  List containing the runtime dependencies of the app as File instances.

### getTestDependencies

    @groovy.transform.CompileStatic
    java.util.List getTestDependencies()

  List containing the test-time dependencies of the app as File instances.

### getWebXmlLocation

    java.io.File getWebXmlLocation()

### handleInlinePlugin

    @groovy.transform.CompileStatic
    void handleInlinePlugin(java.lang.String pluginName, java.io.File dir, DependencyManager dependencyManager)

### initialiseDefaultLog4j

    @groovy.transform.CompileStatic
    static void initialiseDefaultLog4j(java.lang.ClassLoader classLoader)

### initializeResourcesDir

    @groovy.transform.CompileStatic
    void initializeResourcesDir()

### isDependenciesExternallyConfigured

    boolean isDependenciesExternallyConfigured()

### isGrailsProject

    @groovy.transform.CompileStatic
    boolean isGrailsProject()

### isPluginProject

    boolean isPluginProject()

### isRegisteredInMetadata

    boolean isRegisteredInMetadata(java.lang.String pluginName)

### loadBuildPropertiesFromClasspath

    @groovy.transform.CompileStatic
    protected void loadBuildPropertiesFromClasspath(java.util.Properties buildProps)

### loadConfig

    groovy.util.ConfigObject loadConfig(java.lang.String environment = null)

  Loads the application's BuildSettings.groovy file if it exists and returns the corresponding config object. If the file does not exist, this returns an empty config.

### loadConfig

    @groovy.transform.CompileStatic
    groovy.util.ConfigObject loadConfig(java.io.File configFile, java.lang.String environment = null)

  Loads the given configuration file if it exists and returns the corresponding config object. If the file does not exist, this returns an empty config.

### loadConfig

    @groovy.transform.CompileStatic
    groovy.util.ConfigObject loadConfig(groovy.lang.Script script, java.lang.String environment = null)

  Loads the given script and returns corresponding config object. If the file does not exist, this returns an empty config.

### loadConfig

    @groovy.transform.CompileStatic
    groovy.util.ConfigObject loadConfig(groovy.util.ConfigObject config)

### loadSettingsFile

    @groovy.transform.CompileStatic
    protected groovy.util.ConfigObject loadSettingsFile()

### makeAbsolute

    protected java.io.File makeAbsolute(java.io.File dir)

### notDefinedInBuildConfig

    @java.lang.Deprecated
    boolean notDefinedInBuildConfig(java.lang.String pluginName)

### obtainGroovyClassLoader

    groovy.lang.GroovyClassLoader obtainGroovyClassLoader()

### parseGrailsBuildListeners

    protected void parseGrailsBuildListeners()

### postLoadConfig

    protected void postLoadConfig()

### setBaseDir

    @groovy.transform.CompileStatic
    void setBaseDir(java.io.File newBaseDir)

  Changes the base directory, making sure that everything that depends on it gets refreshed too. If you have have previously loaded a configuration file, you should load it again after calling this method.

  Warning This method resets the project paths, so if they have been set manually by the caller, then that information will be lost!

### setBuildDependencies

    @groovy.transform.CompileStatic
    void setBuildDependencies(java.util.List deps)

  Sets the runtime dependencies for the project

### setBuildListeners

    void setBuildListeners(java.lang.Object buildListeners)

### setClassesDir

    void setClassesDir(java.io.File dir)

### setCompileDependencies

    @groovy.transform.CompileStatic
    void setCompileDependencies(java.util.List deps)

  Sets the compile time dependencies for the project

### setConvertClosuresArtefacts

    void setConvertClosuresArtefacts(boolean convert)

### setDependenciesExternallyConfigured

    void setDependenciesExternallyConfigured(boolean dependenciesExternallyConfigured)

### setGrailsWorkDir

    void setGrailsWorkDir(java.io.File dir)

### setLogScriptTiming

    void setLogScriptTiming(boolean b)

### setPluginBuildClassesDir

    void setPluginBuildClassesDir(java.io.File dir)

### setPluginClassesDir

    void setPluginClassesDir(java.io.File dir)

### setPluginIncludeSource

    void setPluginIncludeSource(boolean include)

### setPluginProvidedClassesDir

    void setPluginProvidedClassesDir(java.io.File dir)

### setPluginStagingDir

    void setPluginStagingDir(java.io.File dir)

### setProjectTargetDir

    void setProjectTargetDir(java.io.File dir)

### setProjectWarExplodedDir

    void setProjectWarExplodedDir(java.io.File dir)

### setProjectWarFile

    void setProjectWarFile(java.io.File file)

### setProjectWarOsgiHeaders

    void setProjectWarOsgiHeaders(boolean flag)

### setProjectWorkDir

    void setProjectWorkDir(java.io.File dir)

### setProvidedDependencies

    @groovy.transform.CompileStatic
    void setProvidedDependencies(java.util.List deps)

  Sets the runtime dependencies for the project

### setResourcesDir

    void setResourcesDir(java.io.File dir)

### setRuntimeDependencies

    @groovy.transform.CompileStatic
    void setRuntimeDependencies(java.util.List deps)

  Sets the runtime dependencies for the project

### setSourceDir

    void setSourceDir(java.io.File dir)

### setTestClassesDir

    void setTestClassesDir(java.io.File dir)

### setTestDependencies

    @groovy.transform.CompileStatic
    void setTestDependencies(java.util.List deps)

  Sets the test time dependencies for the project

### setTestReportsDir

    void setTestReportsDir(java.io.File dir)

### setTestSourceDir

    void setTestSourceDir(java.io.File dir)

### setVerboseCompile

    void setVerboseCompile(boolean flag)

### setWebXmlLocation

    void setWebXmlLocation(java.io.File location)

### shouldResolve

    protected boolean shouldResolve()

### storeDependencyCache

    @groovy.transform.CompileStatic
    void storeDependencyCache()

Groovy Documentation